#include <bits/stdc++.h>
using namespace std;
int t;
int n,m;
long long a[75005],b[75005];
long long pn;
int op;
int main() {
cin >> t;
while(t--) {
        op=0;
        pn=1e18;
cin >> n >> m;
    for(int i=1; i<=n; i++){
    cin >> a[i];
    }
    for(int i=1; i<=m; i++){
    cin >> b[i];
    }
sort(a+1, a+n+1);
    for(int i=1; i<n; i++){
        pn=min(pn,a[i+1]-a[i]);
    }

    for(int i=1; i<n; i++){
    if((a[i+1]-a[i])%pn!=0){
        cout << 0 << endl;
        op=1;
        break;
        }
    }
if(op==0){
        op=2;
    for(int i=1; i<=n; i++)
    if(b[i]==a[i]) {
        cout << 0 << endl;
        op=1;
        break;
        }
}
if(op==2) cout << 1 << endl;
}

return 0;
}